-- name: [CS] Pikmin Captains
-- description: Pikmin Captains \nby SwagSkeleton95 \n\nRequires Character Select!

local E_MODEL_OLIMAR = smlua_model_util_get_id("olimar_geo")

local E_MODEL_LOUIE = smlua_model_util_get_id("louie_geo")

local TEX_OLIMAR_ICON = get_texture_info("olimar-icon")

local TEX_LOUIE_ICON = get_texture_info("louie-icon")

local TEXT_MOD_NAME = "Pikmin Captains"

local PALETTE_OLIMAR= {
    [PANTS]  = "FFFF94",
    [SHIRT]  = "FFFF94",
    [GLOVES] = "FF0000",
    [SHOES]  = "FF0000",
    [HAIR]   = "632021",
    [SKIN]   = "FFD384",
    [CAP]    = "E7A67B",
    [EMBLEM] = "FF0000",
}

local PALETTE_LOUIE= {
    [PANTS]  = "FFFF94",
    [SHIRT]  = "FFFF94",
    [GLOVES] = "0010FF",
    [SHOES]  = "0010FF",
    [HAIR]   = "FFF300",
    [SKIN]   = "FFDFA5",
    [CAP]    = "E7864A",
    [EMBLEM] = "0010FF",
}

local CAP_OLIMAR = {
    normal = smlua_model_util_get_id("olimarcap_geo"),
    wing = smlua_model_util_get_id("olimarwingcap_geo"),
    metal = smlua_model_util_get_id("olimarmetalcap_geo"),
    metalWing = smlua_model_util_get_id("olimarmetalwingcap_geo")
}

local CAP_LOUIE = {
    normal = smlua_model_util_get_id("louiecap_geo"),
    wing = smlua_model_util_get_id("louiewingcap_geo"),
    metal = smlua_model_util_get_id("louiemetalcap_geo"),
    metalWing = smlua_model_util_get_id("louiemetalwingcap_geo")
}

local VOICETABLE_OLIMAR = {
    [CHAR_SOUND_ATTACKED] = 'ogasp6.mp3',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'oidle6.mp3',
    [CHAR_SOUND_HAHA] = 'olimar.mp3',
    [CHAR_SOUND_HAHA_2] = 'oidle2.mp3',
    [CHAR_SOUND_HERE_WE_GO] = 'olimar.mp3',
    [CHAR_SOUND_HOOHOO] = 'oidle3.mp3',
    [CHAR_SOUND_ON_FIRE] = 'oyawn.mp3',
    [CHAR_SOUND_OOOF] = 'ogasp8.mp3',
    [CHAR_SOUND_OOOF2] = 'ogasp5.mp3',
    [CHAR_SOUND_PUNCH_HOO] = 'punch.mp3',
    [CHAR_SOUND_PUNCH_WAH] = 'punchair.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'punch.mp3',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'olimar.mp3',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'oidle3.mp3',
    [CHAR_SOUND_WAAAOOOW] = 'oidle2.mp3',
    [CHAR_SOUND_WAH2] = 'olimar.mp3',
    [CHAR_SOUND_WHOA] = 'oidle5.mp3',
    [CHAR_SOUND_YAHOO] = 'olimar.mp3',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'ogasp3.mp3',
    [CHAR_SOUND_YAH_WAH_HOO] = {'ogasp1.mp3', 'ogasp2.mp3', 'oidle1.mp3'},
    [CHAR_SOUND_OKEY_DOKEY] = 'nothing.mp3',
    [CHAR_SOUND_LETS_A_GO] = 'olimar.mp3',
    [CHAR_SOUND_DYING] = 'oyawn.mp3',
    [CHAR_SOUND_DROWNING] = 'oyawn.mp3',
    [CHAR_SOUND_EEUH] = 'oyawn.mp3',
    [CHAR_SOUND_MAMA_MIA] = 'oyawn.mp3',
    [CHAR_SOUND_DOH] = 'ogasp4.mp3',
    [CHAR_SOUND_HRMM] = 'ogasp1.mp3',
    [CHAR_SOUND_PANTING] = 'ogasp2.mp3',
    [CHAR_SOUND_UH] = 'ogasp3.mp3',
}

local VOICETABLE_LOUIE = {
    [CHAR_SOUND_ATTACKED] = 'lgasp6.mp3',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'lidle6.mp3',
    [CHAR_SOUND_HAHA] = 'louie.mp3',
    [CHAR_SOUND_HAHA_2] = 'lidle2.mp3',
    [CHAR_SOUND_HERE_WE_GO] = 'louie.mp3',
    [CHAR_SOUND_HOOHOO] = 'lidle1.mp3',
    [CHAR_SOUND_ON_FIRE] = 'lidle7.mp3',
    [CHAR_SOUND_OOOF] = 'lgasp6.mp3',
    [CHAR_SOUND_OOOF2] = 'lgasp5.mp3',
    [CHAR_SOUND_PUNCH_HOO] = 'punch.mp3',
    [CHAR_SOUND_PUNCH_WAH] = 'punchair.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'punch.mp3',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'louie.mp3',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'lidle1.mp3',
    [CHAR_SOUND_WAAAOOOW] = 'lidle2.mp3',
    [CHAR_SOUND_WAH2] = 'louie.mp3',
    [CHAR_SOUND_WHOA] = 'lidle5.mp3',
    [CHAR_SOUND_YAHOO] = 'louie.mp3',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'lgasp3.mp3',
    [CHAR_SOUND_YAH_WAH_HOO] = {'lgasp1.mp3', 'lgasp2.mp3', 'lidle1.mp3'},
    [CHAR_SOUND_OKEY_DOKEY] = 'nothing.mp3',
    [CHAR_SOUND_LETS_A_GO] = 'louie.mp3',
    [CHAR_SOUND_DYING] = 'lidle7.mp3',
    [CHAR_SOUND_DROWNING] = 'lidle7.mp3',
    [CHAR_SOUND_EEUH] = 'lidle7.mp3',
    [CHAR_SOUND_MAMA_MIA] = 'lidle7.mp3',
    [CHAR_SOUND_DOH] = 'lgasp4.mp3',
    [CHAR_SOUND_HRMM] = 'lgasp1.mp3',
    [CHAR_SOUND_PANTING] = 'lgasp3.mp3',
    [CHAR_SOUND_UH] = 'lgasp3.mp3',
}

if _G.charSelectExists then
    _G.CT_OLIMAR = _G.charSelect.character_add("Captain Olimar", {"Captain Olimar from the Pikmin Franchise"}, "SwagSkeleton95", {r = 255, g = 20, b = 20}, E_MODEL_OLIMAR, CT_MARIO, TEX_OLIMAR_ICON)
    _G.CT_LOUIE = _G.charSelect.character_add("Louie", {"Louie from the Pikmin Franchise"}, "SwagSkeleton95", {r = 20, g = 20, b = 255}, E_MODEL_LOUIE, CT_LUIGI, TEX_LOUIE_ICON)

    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_OLIMAR, VOICETABLE_OLIMAR)
    _G.charSelect.character_add_caps(E_MODEL_OLIMAR, CAP_OLIMAR)
    _G.charSelect.character_add_palette_preset( E_MODEL_OLIMAR, PALETTE_OLIMAR)
    _G.charSelect.character_add_voice(E_MODEL_LOUIE, VOICETABLE_LOUIE)
    _G.charSelect.character_add_caps(E_MODEL_LOUIE, CAP_LOUIE)
    _G.charSelect.character_add_palette_preset( E_MODEL_LOUIE, PALETTE_LOUIE)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_OLIMAR then return _G.charSelect.voice.sound(m, sound) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_LOUIE then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_OLIMAR then return _G.charSelect.voice.snore(m) end
        if _G.charSelect.character_get_voice(m) == VOICETABLE_LOUIE then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end